var sz = 500;
var a = (sz * 3) / 16;
var b = a * 2.25;

var speed = 5; // скорость движения электронов

function rot_point(x, y, rot) {
  var tmp = x - sz / 2;
  x = (x - sz / 2) * cosdeg(rot) - (y - sz / 2) * sindeg(rot) + sz / 2;
  y = tmp * sindeg(rot) + (y - sz / 2) * cosdeg(rot) + sz / 2;
  return { x: x, y: y };
}

function draw_electron(deg) {
  ctx.clearRect(0, 0, sz, sz);
  draw_atom();

  var pos = [deg - 90, deg - 20, deg + 20];

  var r = sz / 12;
  var cols = ["#e15b64", "#f8b26a", "#abbd81"];
  for (var i = 0; i < 3; i++) {
    ctx.lineWidth = 1;
    ctx.fillStyle = cols[i];
    ctx.beginPath();
    var rp = rot_point(
      sz / 2 + a * cosdeg(pos[i]),
      sz / 2 + b * sindeg(pos[i]),
      i * 60
    );
    ctx.ellipse(rp.x, rp.y, r, r, 0, 0, 2 * Math.PI);
    ctx.closePath();
    ctx.fill();
  }

  setTimeout(draw_electron, 10, (deg + speed) % 360);
}

function draw_atom() {
  ctx.lineWidth = 14;
  ctx.strokeStyle = "#f1f2f3";

  for (var i = 0; i < 3; i++) {
    ctx.beginPath();
    ctx.ellipse(sz / 2, sz / 2, a, b, (60 * i * Math.PI) / 180, 0, 2 * Math.PI);
    ctx.closePath();
    ctx.stroke();
  }
}

var ctx;
function draw() {
  var obj = document.getElementById("drawing");
  if (obj.getContext) {
    ctx = obj.getContext("2d");
    draw_electron(0);
  }
}

function tandeg(degrees) {
  return Math.tan((degrees * Math.PI) / 180);
}
function sindeg(degrees) {
  return Math.sin((degrees * Math.PI) / 180);
}
function cosdeg(degrees) {
  return Math.cos((degrees * Math.PI) / 180);
}